﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.28
@EndOfDesignText@
''#DesignerProperty: Key: BooleanExample, DisplayName: Show Seconds, FieldType: Boolean, DefaultValue: True
''#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Text color

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Private Radius As Int
	Private ProgressValue As Int
	Private LastBall As Long
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	LastBall=0
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
  	'Dim clr As Int = xui.PaintOrColorToColor(Props.Get("TextColor")) 'Example of getting a color value from Props
	mBase.Color=xui.Color_Transparent
	Radius=Min(mBase.Width,mBase.Height)/2
	
	Draw(0)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub

Private Sub Draw(PerCent As Int)
	Dim Can As B4XCanvas
	Can.Initialize(mBase)
	
	Can.DrawCircle(Can.TargetRect.CenterX,Can.TargetRect.CenterY,Radius,xui.Color_White,True,1dip)
	For i=1 To 3
		Can.DrawCircle(Can.TargetRect.CenterX,Can.TargetRect.CenterY,(Radius/3)*i,xui.Color_Blue,False,1dip)
	Next
	
	Can.DrawLine(0,Can.TargetRect.Centery,Can.TargetRect.Width,Can.TargetRect.CenterY,xui.Color_Blue,1dip)
	Can.DrawLine(Can.TargetRect.CenterX,0,Can.TargetRect.CenterX,Can.TargetRect.Height,xui.Color_Blue,1dip)
	
	'canv.DrawLine(CoX-StarSize-Rnd(1dip,3dip),CoY,CoX+StarSize+Rnd(1dip,3dip),CoY,Colors.White,1DiP)
		
	For i=0 To 180
		Dim CoX As Int = Can.TargetRect.CenterX-Radius*CosD(360*((PerCent+(i/7.2))/100))
		Dim CoY As Int = Can.TargetRect.CenterY-Radius*SinD(360*((PerCent+(I/7.2))/100))
		Can.DrawLine(Can.TargetRect.CenterX,Can.TargetRect.CenterY,CoX,CoY,xui.Color_ARGB(i/4,80,80,165+i/2),2dip)
	Next
	
	Dim CoX As Int = Can.TargetRect.CenterX-Radius*CosD(360*((PerCent+25)/100))
	Dim CoY As Int = Can.TargetRect.CenterY-Radius*SinD(360*((PerCent+25)/100))
	Can.DrawLine(Can.TargetRect.CenterX,Can.TargetRect.CenterY,CoX,CoY,xui.Color_Blue,2dip)
	
	If LastBall+250<DateTime.Now Then Ball(PerCent)
End Sub

Private Sub Ball(Value As Int)
	Dim Bl As B4XView = xui.CreatePanel("")
	Dim Can As B4XCanvas
	Dim X As Int = mBase.Width/2-Rnd(20dip,Radius-10dip)*CosD(360*((Value+20)/100))
	Dim Y As Int = mBase.Height/2-Rnd(20dip,Radius-10dip)*SinD(360*((Value+20)/100))
	Dim TimeLapse As Int = 600
	
	mBase.AddView(Bl,X-2dip,Y-2dip,4dip,4dip)
	Can.Initialize(Bl)
	Can.DrawCircle(2dip,2dip,2dip,xui.Color_ARGB(80,40,40,255) ,True,1dip)
	LastBall=DateTime.Now
	Bl.SetLayoutAnimated(TimeLapse,X-10dip,Y-10dip,20dip,20dip)
	'Bl.SetVisibleAnimated(TimeLapse,False)
	Sleep(TimeLapse)
	Bl.RemoveViewFromParent
End Sub

' Value 0..100
Public Sub setValue(ForCent As Int)
	ForCent=ForCent Mod 100
	ProgressValue=ForCent
	Draw(ForCent)
End Sub

Public Sub getValue As Int
	Return ProgressValue
End Sub